Revit二次开发之“使用ElementTransformUtils.MoveElement()移动元素”

使用ElementTransformUtils.MoveElement()移动元素,改变元素的Location属性
[Transaction(TransactionMode.Manual)]
[Regeneration(RegenerationOption.Manual)]
// [Journaling(JournalingMode.NoCommandData)]
public   class  cmdMoveColumn : IExternalCommand
{
    
public  Result Execute(ExternalCommandData cmdData,  ref   string  message, ElementSet elements)
    {
        UIDocument uiDoc 
=  cmdData.Application.ActiveUIDocument;
        Selection selection 
=  uiDoc.Selection;

        Transaction ts 
=   new  Transaction(uiDoc.Document,  " move " );
        ts.Start();

        
// 选择一个管件,可以转化为FamilyInstance
        Reference refelem  =  selection.PickObject(ObjectType.Element,  " 选择一个管件 " );
        FamilyInstance fi 
=  uiDoc.Document.get_Element(refelem.ElementId)  as  FamilyInstance;
        MoveColumn(uiDoc.Document, fi);

        ts.Commit();

        
return  Result.Succeeded;
    }
    
public   void  MoveColumn(Document doc, FamilyInstance column)
    {
        LocationPoint columnLocation 
=  column.Location  as  LocationPoint;
        XYZ oldPlace 
=  columnLocation.Point;
        XYZ newPlace 
=   new  XYZ( 10 20 30 );
        ElementTransformUtils.MoveElement(doc, column.Id, newPlace);
        columnLocation 
=  column.Location  as  LocationPoint;
        XYZ newActual 
=  columnLocation.Point;
        
string  info  =   " Original Z location: "   +  oldPlace.Z  +
            
" \nNew Z location: "   +  newActual.Z;
        TaskDialog.Show(
" Revit " , info);
    }
    
bool  MoveUsingLocationCurve(UIApplication app, Wall wall)
    {
        LocationCurve wallLine 
=  wall.Location  as  LocationCurve;
        XYZ translationVec 
=   new  XYZ( 10 20 0 );
        
return  (wallLine.Move(translationVec));
    }
    
void  MoveUsingCurveParam(UIApplication app, Wall wall)
    {
        LocationCurve wallLine 
=  wall.Location  as  LocationCurve;
        XYZ p1 
=  XYZ.Zero;
        XYZ p2 
=   new  XYZ( 10 20 0 );
        Line newWallLine 
=  app.Application.Create.NewLineBound(p1, p2);
        wallLine.Curve 
=  newWallLine;
    }
}
from: http://revit.5d6d.com/thread-1206-1-1.html
  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值